// NOM PRENOM Numéro étudiant 
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>

#include <condition_variable>
#include <mutex>
#include <string>
#include <thread>
#include <vector>
#include <queue>
#include <iostream>

using namespace std; 

//LIGNE DE COMPILATION
//g++ sujet.cpp  -g -O0 -Wall -Wextra  -std=c++11  -pthread -o sujet

int nb_bateaux   = 10;
int nb_canons    = 5;
int nb_armuriers = 0;
int port         = 10;
int timeout      = 10;

bool par = false;

bool* a_flot;

int nb_coules = 0;

////////////////////////////////////////////
////////////////////////////////////////////
/* FONCTIONS AUXILIAIRES, NE PAS MODIFIER */
int bateaux_arrives = 0;
int assez_bateaux;
int assez_coules;

bool succes_attaque = false;
bool succes_defense    = false;

struct timeval tv0;;
void timeout_jeu(int timeout){
  sleep(timeout);
  if (not succes_attaque)
    cout << "Attaque trop lente ! l'armada est vaincue !!" << endl;
  exit(1);
}

void init() {
  srand(time(NULL));
  gettimeofday(&tv0, nullptr);
  a_flot  = new bool[nb_bateaux];
  // Par défaut, un soldat est vivant.
  for (int i = 0; i < nb_bateaux; i++)
    a_flot[i]  = true;

  /* 60% des bateaux sont nécessaires pour tirer une salve commune */
  assez_bateaux = .6 * nb_bateaux;
  /* Si plus de 40% des bateaux sont coulés, la défense gagne */
  assez_coules   = .4 * nb_bateaux;

  /* l'attaque doit se terminer en moins de "timeout" secondes */
  thread(timeout_jeu, timeout).detach();
}

void parse_command_line(int argc, char** argv) {
  for (int i = 1; i < argc; i++) {
    if (string(argv[i]) == "--timeout") {
      i++;
      timeout = stoi(argv[i]);
    } else if (string(argv[i]) ==  "--nb-bateaux") {
      i++;
      nb_bateaux = stoi(argv[i]);
    }  else if (string(argv[i]) ==  "--nb-canons") {
      i++;
      nb_canons = stoi(argv[i]);
    } else if (string(argv[i]) ==  "--par") {
      par     = true;
    } else if (string(argv[i]) ==  "--nb-armuriers") {
      i++;
      par     = true;
      nb_armuriers = stoi(argv[i]);
    } else {
      cout << "ERROR: Unknown option: " << argv[i] << endl;
      exit (1);
    }
  }
  cout << "Temps de jeu: " << timeout      << endl;
  cout << "nb_bateaux: "    << nb_bateaux   << endl;
  cout << "nb_canons: "     << nb_canons    << endl;
  cout << "nb_armuriers: "  << nb_armuriers << endl;
}

double timevalsub(struct timeval *tv1, const struct timeval *tv2) {
  double res = 0;
  res = tv2->tv_sec - tv1->tv_sec;
  res += (tv2->tv_usec - tv1->tv_usec)*1.0/1000000;
  return res;
}

/* FIN DES FONCTIONS AUXILIAIRES          */
////////////////////////////////////////////
////////////////////////////////////////////

/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/* CODE DU DÉFENSEUR : À LIRE MAIS NE PAS MODIFIER ! */

void boulet() {
  struct timeval tv1;
  /* Va chercher un boulet, prend 1 seconde */
  sleep(1);
  gettimeofday(&tv1, nullptr);
  fprintf(stdout, "Un boulet est arrivé au temps %.2f\n", timevalsub(&tv0, &tv1));
}

bool tire(int id){
  struct timeval tv1;
  /* Cela prend 0.25 seconde pour tirer */
  usleep(250000);
  gettimeofday(&tv1, nullptr);
  fprintf(stdout, "Canon %d tire au temps %.2f\n", id, timevalsub(&tv0, &tv1));
  
  int cible = rand() % nb_bateaux;
  if (rand() % 5  == 0 && (a_flot[cible])){
    cout << "Bateau " << cible << " a été coulé!" << endl; 
    a_flot[cible] = false;
    return true;
  } else
    return false;
}

void canon(int id) {
  do {
    boulet();    
    if (tire(id)) {
      nb_coules++;

      if (nb_coules > assez_coules)
	/* Plus assez de bateaux pour tirer une salve commune, on a gagné */
      	succes_defense = true;
    }
  } while(not succes_attaque && (not succes_defense));
}

/* FIN DU CODE NON MODIFIABLE DU DEFENSEUR */
/////////////////////////////////////////////
//////// DÉFENSE SÉQUENTIELLE

void defense(){
  cout << "Défendons le port!!" << endl;
  canon(0);
}

mutex m;

void canon_thread(int id) {
  /* À COMPLÉTER */
  do {
    boulet();    
    if (tire(id)) {
      m.lock();
      nb_coules++;

      if (nb_coules > assez_coules)
	/* Plus assez de bateaux pour tirer une salve commune, on a gagné */
      	succes_defense = true;
      m.unlock();
    }
  } while(not succes_attaque && (not succes_defense));
}
  
//////// DÉFENSE PARALLÈLE
void defense_par() {
  /* À COMPLÉTER */
  vector<thread> canons;

  for (int i = 0; i < nb_canons; i++) {
    canons.push_back(thread(canon_thread, i));
  }

  for (int i = 0; i < nb_canons; i++) {
    canons[i].join();
  }    
}

//////// DÉFENSE PARALLÈLE AVEC ARMURIERS
class Boulets {
  /* À COMPLÉTER */
  int max_boulets;
  int nb_boulets = 0;
  std::mutex m;
  std::condition_variable plein;
  std::condition_variable vide;
public:
  Boulets(int n):max_boulets(n){}
  void prend() {
     /* À COMPLÉTER */
    std::unique_lock<std::mutex> lck(m);
    while (nb_boulets == 0)
      vide.wait(lck);

    nb_boulets--;
    plein.notify_one();
  }
 
  void pose() {
     /* À COMPLÉTER */
    std::unique_lock<std::mutex> lck(m);
    while (nb_boulets == max_boulets)
      plein.wait(lck);
    nb_boulets++;
    vide.notify_one();
  }
};

void canon_avec_armurier(int id, Boulets& pile) {
  /* À COMPLÉTER */
  do {
    pile.prend();    
    if (tire(id)) {
      m.lock();
      nb_coules++;

      if (nb_coules > assez_coules)
	/* Plus assez de bateaux pour tirer une salve commune, on a gagné */
      	succes_defense = true;
      m.unlock();
    }
  } while(not succes_attaque && (not succes_defense));
}

void armurier(Boulets& pile) {
  do {
  /* À COMPLÉTER */
    boulet();
    pile.pose();
  } while(not succes_attaque && (not succes_defense));
}

void defense_avec_armuriers() {
  /* À COMPLÉTER */
  vector<thread> canons;
  vector<thread> armuriers;

  Boulets pile(4*nb_canons);

  for (int i = 0; i < nb_canons; i++) {
    canons.push_back(thread(canon_avec_armurier, i, std::ref(pile)));
  }

  for (int i = 0; i < nb_armuriers; i++) {
    armuriers.push_back(thread(armurier, std::ref(pile)));
  }

  for (int i = 0; i < nb_armuriers; i++) {
    armuriers[i].join();
  }
  for (int i = 0; i < nb_canons; i++) {
    canons[i].join();
  }
}

/////////////////////////////////////////////////////////
/* CODE DE L'ATTAQUANT : À LIRE MAIS NE PAS MODIFIER ! */
double traverse_port(int id) { 
  struct timeval tv1, tv2;
  
  gettimeofday(&tv1, nullptr);
  int start = rand() % 10;

  fprintf(stdout, "Bateau %d  part de %d cases au temps %.2f\n",
	  id, 10 - start, timevalsub(&tv0, &tv1));
  
  for (int i = start ; i < 10 ; i++){
    /* Avance d'une case en 1 seconde */
    sleep(1);

    if (succes_attaque || /* l'armada a gagné */
	succes_defense || /* la défense a gagné  */
	(not a_flot[id])) /* j'ai été coulé */ {
      /* c'est terminé */
      return -1;
    }
  }

  gettimeofday(&tv2, nullptr);
  fprintf(stdout, "Bateau %d prêt à tirer une salve commune au temps %.2f\n",
	  id, timevalsub(&tv0, &tv2));
  
  /* Renvoi le temps auquel le bateau est prêt à tirer sur le barrage */
  return timevalsub(&tv0, &tv2);
}

void detruire_barrage() {
  bateaux_arrives++;
  if (bateaux_arrives == assez_bateaux){
    succes_attaque = true;
  }
}

double bateau(int id) {
  double arrive_a = traverse_port(id);
  if (arrive_a > 0)
    detruire_barrage();
  return arrive_a;
}

//////// ATTAQUE SÉQUENTIELLE
double attaque() {
  double dernier_arrive = 0.0;

  for (int i = 0; i < nb_bateaux; i++)
    dernier_arrive = max(dernier_arrive, bateau(i));

  return dernier_arrive;
}
/* FIN DU CODE NON MODIFIABLE DE L'ATTAQUANT */
/////////////////////////////////////////////////////////

//////// ATTAQUE PARALLÈLE
class Salve {
  unsigned int bateaux_attendus;
  /* À compléter */
  mutex m;
  condition_variable_any assez_bateaux;
  unsigned int bateaux_arrives = 0;
public:
  Salve(unsigned int n) : bateaux_attendus (n){};
  void detruire_barrage() {
    /* À compléter */
    std::unique_lock<std::mutex> lck(m);
    bateaux_arrives++;
    if (bateaux_arrives >= bateaux_attendus) {
      succes_attaque = true;
      assez_bateaux.notify_all();
    } else {
      // il faut attendre
      assez_bateaux.wait(m);
    }
  }
};

void bateau_thread(int id, Salve& salve, double& temps_arrivee ) {
  temps_arrivee = traverse_port(id);
  /* À compléter */
  if (temps_arrivee > 0)
    salve.detruire_barrage();
}

double attaque_par(){
  double dernier_arrive = 0.0;
   /* À compléter */
  vector<thread> bateaux;
  double temps_arrivee[nb_bateaux];
  Salve salve(assez_bateaux);

  for (int i = 0; i < nb_bateaux; i++) {
    bateaux.push_back(thread(bateau_thread, i, ref(salve), ref(temps_arrivee[i])));
  }

  for (int i = 0; i < nb_bateaux; i++) {
    bateaux[i].join();
    dernier_arrive = max(dernier_arrive, temps_arrivee[i]);
  }
  return dernier_arrive;
}

/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/* MAIN() : NE PAS MODIFIER ! */
int main(int argc, char ** argv) {
  double dernier_arrive = 0.0;
  thread defense_thread;

  /* lecture des arguments en ligne de commande */
  parse_command_line(argc, argv);
  /* initialisation de différents paramètres */
  init();

   if (par) {    
    if(nb_armuriers > 0) {
      defense_thread = thread(defense_avec_armuriers);
    } else {
      defense_thread = thread(defense_par);
    }

    dernier_arrive = attaque_par();
  } else {
    defense_thread = thread(defense);
    dernier_arrive = attaque();
  } 
  
  cout << endl;
  if (succes_attaque) {
    cout << "Bam! Le barrage est tombé!!" << endl << endl;
    cout << "Le dernier bateau est arrivé après " << dernier_arrive << " secondes." << endl;
  } else {
    cout << nb_coules << " bateaux ont été coulés! La défense gagne!!" << endl << endl;
  }

  defense_thread.join();
  return 0;
}
